unit Unit1;

{
 calculate GCD / LCM
 used algorithm is EUCLID/recursive
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons,shellApi, ExtCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    StaticText1: TStaticText;
    Label3: TLabel;
    BitBtn1: TBitBtn;
    Image1: TImage;
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure BitBtn1Click(Sender: TObject);
    procedure Image1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

function GCD(a,b : Int64) : Int64;
//b <> 0
begin
 if a = 0 then result := b
  else if a < b then result := GCD(b,a)
  else result := GCD(a mod b,b);
end;

function IntFilter(ch : char) : char;
//allow only 0..9
begin
 if (ch in ['0'..'9',#08]) then result := ch
  else result := #00;
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
 key := Intfilter(key);
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
//GO
var A,B,C : Int64;
begin
 if length(edit1.Text) = 0 then edit1.Text := '1';
 if length(edit2.Text) = 0 then edit2.Text := '1';
 A := strtoint64(edit1.Text);
 B := strtoint64(edit2.Text);
 C := GCD(A,B);
 statictext1.Caption := inttostr(C);
end;

procedure TForm1.Image1Click(Sender: TObject);
begin
 ShellExecute(0,'open','http://www.davdata.nl/math/', nil, nil, SW_SHOWNORMAL);//
end;

end.


